#!/usr/local/bin/perl
# find_files.cgi
# File the tapes containing certain files

require './bacula-restore-lib.pl';
&ReadParse();
$in{'files'} =~ s/\r//g;
$in{'files'} || &error($text{'find_efiles'});

&header($text{'find_title'}, "");
print "<hr>\n";

if ($in{'job'}) {
	$jobsql = "and Job.JobId = $in{'job'}";
	}

# Prepare SQL
$dbh = &connect_to_database();
$cmd = $dbh->prepare("
select File.FileId, File.PathId, File.FilenameId, File.JobId
from File, Filename, Path, Job
where File.FilenameId = Filename.FilenameId
and File.PathId = Path.PathId
and Path.Path = ?
and File.JobId = Job.JobId
$jobsql
order by Job.EndTime desc
");
$cmd || &error(&text('esql', $dbh->errstr));

$cmd2 = $dbh->prepare("
select Media.VolumeName,Job.Name,Job.SchedTime
from Media, JobMedia, Job
where JobMedia.JobId = Job.JobId
and Job.JobId = ?
and JobMedia.MediaId = Media.MediaId
");
$cmd2 || &error(&text('esql', $dbh->errstr));

# Execute SQL to find each file
foreach $f (split(/\n/, $in{'files'})) {
	$winf = &unix_to_dos($f);
	if ($winf =~ /^(^.*\/)([^\/]*)$/) {
		local $path = $1;
		local $filename = $2;
		$cmd->execute($path) ||
			&error(&text('esql', $dbh->errstr));
		local ($fid, $pid, $fnid, $jid, $foundany);
		while(($fid, $pid, $fnid, $jid) = $cmd->fetchrow()) {
			# Found a job for this file
			$needjobs{$jid}++;
			$foundany++;
			}
		if ($foundany) {
			# Found at least one for this file
			push(@found, $f);
			}
		else {
			# Could not find!
			push(@notfound, $f);
			}
		$cmd->finish();
		}
	else {
		push(@invalid, $f);
		}
	}

# Tell the user about any problems
if (@invalid) {
	print "<p>$text{'find_einvalid'}<p>\n";
	foreach $i (@invalid) {
		print "<tt>$i</tt><br>\n";
		}
	print "<p>\n";
	}
if (@notfound) {
	print "<p>$text{'find_enotfound'}<p>\n";
	foreach $i (@notfound) {
		print "<tt>$i</tt><br>\n";
		}
	print "<p>\n";
	}

# Work out which tape to mount, by looking for volumes
@jobs = $in{'job'} ? ( $in{'job'} ) : ( keys %needjobs );
foreach $j (@jobs) {
	$cmd2->execute($j) ||
		&error(&text('esql', $dbh->errstr));
	while(($vol, $jobname, $jobwhen) = $cmd2->fetchrow()) {
		push(@vols, $vol);
		push(@jobnames, $jobname);
		$jobwhen =~ s/ .*$//;
		push(@jobwhens, $jobwhen);
		}
	$cmd2->finish();
	}
@vols = &unique(@vols);
if (!@vols || !@found) {
	# No files found?
	print "$text{'find_enone'}<p>\n";
	}
else {
	# Can go ahead ..
	print "<form action=restore.cgi method=post>\n";
	if (@vols > 1) {
		print &text('find_vols', scalar(@found)),"\n";
		}
	else {
		print &text('find_vol', scalar(@found), "<tt>$vols[0]</tt>"),"<p>\n";
		print "<input type=hidden name=vol value='$vols[0]'>\n";
		}
	foreach $f (@found) {
		print "<input type=hidden name=file value='",
		      &html_escape($f),"'>\n";
		}
	print "<table>\n";
	if (@vols > 1) {
		print "<tr> <td><b>$text{'find_rvol'}</b></td>\n";
		print "<td><select name=vol>\n";
		foreach $v (@vols) {
			print "<option>$v\n";
			}
		print "</select></td> </tr>\n";
		}

	print "<tr> <td><b>$text{'find_rjob'}</b></td>\n";
	print "<td><select name=job>\n";
	for($i=0; $i<@jobs; $i++) {
		print "<option value=$jobs[$i]>$jobnames[$i] ($jobs[$i]) ($jobwhens[$i])\n";
		}
	print "</select></td> </tr>\n";

	print "<tr> <td><b>$text{'find_rtape'}</b></td>\n";
	print "<td>\n";
	&tape_select();
	print "</td> </tr>\n";

	print "<tr> <td><b>$text{'find_rclient'}</b></td>\n";
	print "<td>";
	&client_select($dbh);
	print "</td> </tr>\n";

	print "<tr> <td><b>$text{'find_rto'}</b></td>\n";
	print "<td><input name=rto size=40 value='/tmp/bacula-restores'>\n";
	print "<input type=submit value='$text{'find_ok'}'></td> </tr>\n";
	print "</table>\n";
	print "</form>\n";
	}

$dbh->disconnect();

print "<hr>\n";
&footer("", $text{'index_return'});


