#!/usr/local/bin/perl
# search_files.cgi
# Ensure that the entered files are on the mounted volume

require './bacula-restore-lib.pl';
&ReadParse();
$in{'tape'} ||= $in{'other'};
$in{'files'} =~ s/\r//g;
$in{'files'} || &error($text{'search_efiles'});

&header($text{'search_title'}, "");
print "<hr>\n";

if ($in{'job'}) {
	$jobsql = "and Job.JobId = $in{'job'}";
	}

# Prepare SQL
$dbh = &connect_to_database();
$cmd = $dbh->prepare("
select File.FileId, File.PathId, File.FilenameId, File.JobId
from File, Filename, Path, Job, JobMedia, Media
where File.FilenameId = Filename.FilenameId
and File.PathId = Path.PathId
and Path.Path = ?
and File.JobId = Job.JobId
and Job.JobId = JobMedia.JobId
and JobMedia.MediaId = Media.MediaId
and Media.VolumeName = ?
$jobsql
");
$cmd || &error(&text('esql', $dbh->errstr));

$cmd2 = $dbh->prepare("
select Name,SchedTime from Job where JobId = ?
");
$cmd2 || &error(&text('esql', $dbh->errstr));

# Execute SQL to find each file
foreach $f (split(/\n/, $in{'files'})) {
	$winf = &unix_to_dos($f);
	if ($winf =~ /^(^.*\/)([^\/]*)$/) {
		local $path = $1;
		local $filename = $2;
		$cmd->execute($path, $in{'vol'}) ||
			&error(&text('esql', $dbh->errstr));
		local ($fid, $pid, $fnid, $jid, $foundany);
		while(($fid, $pid, $fnid, $jid) = $cmd->fetchrow()) {
			# Found a job for this file
			$needjobs{$jid}++;
			$foundany++;
			}
		if ($foundany) {
			# Found at least one for this file
			push(@found, $f);
			}
		else {
			# Could not find!
			push(@notfound, $f);
			}
		$cmd->finish();
		}
	else {
		push(@invalid, $f);
		}
	}
@jobs = $in{'job'} ? ( $in{'job'} ) : ( keys %needjobs );

# Tell the user about any problems
if (@invalid) {
	print "<p>$text{'search_einvalid'}<p>\n";
	foreach $i (@invalid) {
		print "<tt>$i</tt><br>\n";
		}
	print "<p>\n";
	}
if (@notfound) {
	print "<p>$text{'search_enotfound'}<p>\n";
	foreach $i (@notfound) {
		print "<tt>$i</tt><br>\n";
		}
	print "<p>\n";
	}
if (!@found) {
	print "$text{'search_enone'}<p>\n";
	}
else {
	# Work out job names
	foreach $j (@jobs) {
		$cmd2->execute($j);
		local ($jobname, $jobwhen) = $cmd2->fetchrow();
		push(@jobnames, $jobname);
		$jobwhen =~ s/ .*$//;
		push(@jobwhens, $jobwhen);
		$cmd2->finish();
		}

	# Can go ahead ..
	print "<form action=restore.cgi method=post>\n";
	print "<input type=hidden name=vol value='$in{'vol'}'>\n";
	print "<input type=hidden name=tape value='$in{'tape'}'>\n";
	foreach $f (@found) {
		print "<input type=hidden name=file value='",
		      &html_escape($f),"'>\n";
		}
	print &text('search_vol', scalar(@found), "<tt>$in{'vol'}</tt>"),"<p>\n";
	print "<table>\n";
	print "<tr> <td><b>$text{'find_rjob'}</b></td>\n";
	print "<td><select name=job>\n";
	for($i=0; $i<@jobs; $i++) {
		print "<option value=$jobs[$i]>$jobnames[$i] ($jobs[$i]) ($jobwhens[$i])\n";
		}
	print "</select></td> </tr>\n";

	print "<tr> <td><b>$text{'find_rclient'}</b></td>\n";
	print "<td>";
	&client_select($dbh);
	print "</td> </tr>\n";

	print "<tr> <td><b>$text{'find_rto'}</b></td>\n";
	print "<td><input name=rto size=40 value='/tmp/bacula-restores'>\n";
	print "<input type=submit value='$text{'find_ok'}'></td> </tr>\n";

	print "</table></form>\n";
	}

$dbh->disconnect();

print "<hr>\n";
&footer("", $text{'index_return'});


